﻿namespace struktura_listy_konsola_cz2
{
    struct Dane
    {
        public string nazwisko;
        public string imie;
        public string klasa;
    }
    internal class Program
    {
        static Dane d;
        static List<Dane> lista = new List<Dane>();
        static int idBiezacy = 0;

        static void czyscDana()
        {
            d.nazwisko = "";
            d.imie = "";
            d.klasa = "";
        }

        static void dodaj()
        {
            czyscDana();
            Console.WriteLine("nazwisko: ");
            d.nazwisko = Console.ReadLine();
            Console.WriteLine("imię: ");
            d.imie = Console.ReadLine();
            Console.WriteLine("klasa: ");
            d.klasa = Console.ReadLine();
            lista.Add(d);
            idBiezacy = lista.Count - 1;
        }

        static void pokazListe()
        {
            Console.WriteLine("nr\tnazwisko\timię\tklasa");
            for (int i = 0; i < lista.Count; i++)
            {
                Console.WriteLine((i + 1) + "\t"
                    + lista[i].nazwisko + "\t"
                    + lista[i].imie + "\t"
                    + lista[i].klasa);
            }
        }
        
        static void pokazRekord(int id)
        {
            if (id < 0 || id > lista.Count - 1) return;
            d = lista[id];
            Console.WriteLine("\n"+id+ "\t"
                                + d.nazwisko + "\t"
                                + d.imie + "\t"
                                + d.klasa);
        }

        static void pokazPierwszyRekord()
        {
            //pokaz pierwszy rekord
            idBiezacy = 0;
            pokazRekord(idBiezacy);
        }

        static void pokazOstatniRekord()
        {
            //pokaz ostatni rekord
            idBiezacy = lista.Count - 1;
            pokazRekord(idBiezacy);
        }

        static void pokazKolejnyLewy()
        {
            //pokaz kolejny rekord z lewej
            idBiezacy--;
            if (idBiezacy < 0) idBiezacy = 0;
            pokazRekord(idBiezacy);
        }

        static void pokazKolejnyPrawy()
        {
            //pokaz kolejny rekord z prawej
            idBiezacy++;
            if (idBiezacy > lista.Count - 1) idBiezacy = lista.Count - 1;
            pokazRekord(idBiezacy);
        }

        static void pokazWybrany()
        {
            Console.WriteLine("\nPodaj indeks: ");
            idBiezacy = int.Parse(Console.ReadLine());
            pokazRekord(idBiezacy);
        }

        static void usunBiezacy()
        {
            lista.RemoveRange(idBiezacy, 1);
        }

        static void Main(string[] args)
        {
            Console.WriteLine("Witaj w CzD!");
            Console.WriteLine("Wybierz działanie\n" +
                            "+- dodaj dane\n" +
                            "p- pokaz listę\n" +
                            "r- pokaz biezacy\n" +
                            "a- pokaz pierwszy\n" +
                            "<- przeglądaj w lewo\n" +
                            ">- przeglądaj w prawo\n" +
                            "w- pokaz wybrany o indeksie\n" +
                            "u- usuń bieżący\n" +
                            "Esc- koniec");
            ConsoleKeyInfo klawiszInfo;
            do
            {
                klawiszInfo = Console.ReadKey();
                switch (klawiszInfo.KeyChar)
                {
                    case '+': dodaj(); break;
                    case 'p': pokazListe(); break;
                    case 'r': pokazRekord(idBiezacy); break;
                    case 'a': pokazPierwszyRekord(); break;
                    case 'z': pokazOstatniRekord(); break;
                    case '<': pokazKolejnyLewy(); break;
                    case '>': pokazKolejnyPrawy(); break;
                    case 'w': pokazWybrany(); break;
                    case 'u': usunBiezacy(); break;
                }
            } while (klawiszInfo.Key != ConsoleKey.Escape);
        }
    }
}